;--------------------------------------------------------------------
;X1 IPL FD READ CALL ROUTINE
;--------------------------------------------------------------------

;--------------------------------------------------------------------
;IPL-ROM
IPL_FDREAD	equ	0021AH
;
FD_DRIVE	equ	0FF87H
FD_ERR_SP	equ	0FF88H
FD_ERR_RET	equ	0FF8AH
;
IPL_CALL_RAM	equ	0F020H	;tempalte address
;------------------------------------------------
;IPL FD read function call
FD_READ:
	push	hl
;set error handler
	ld	(FD_ERR_SP),sp
	ld	hl,fd_read_error
	ld	(FD_ERR_RET),hl
;
	push	de
	push	bc
	ld	hl,fd_read_scr_s
	ld	de,IPL_CALL_RAM
	ld	bc,fd_read_scr_e-fd_read_scr_s
	ldir
;
	pop	bc
	pop	de
	pop	hl
	ld	b,1dh
	jp	IPL_CALL_RAM
;------------------------
;exec on 8000-FFFF
fd_read_scr_s:
	out	(c),b		;IPL-ROM on
	call	IPL_FDREAD
	or	a
fd_read_join:
	ld	b,1eh
	out	(c),b		;IPL-ROM off
	ret
fd_read_error	equ	$-fd_read_scr_s +IPL_CALL_RAM
	scf
	jr	fd_read_join
fd_read_scr_e:
;------------------------
