;--------------------------------------------------------------------
;StarCruiser X1turbo boot loader with patch
;
;--------------------------------------------------------------------

;------------------------------------------------
;hook entry point for IPL program
;
;  5000-5EFF : patcher code
;  5F00-5FFF : STC IPL FCB
;  6000-6BFF : STC IPL / mfr LOGO
;  F000-???? : IPL LOGO work
;
;------------------------------------------------
;
;	ld	hl,0
;	ld	(02921h),hl


;------------------------------------------------
;hook before startup OS
;
STC_HOOK_1ST_JP		equ	0x60E4		;OS SETUPへのジャンプ
;compatible check
	ld	hl,STC_HOOK_1ST_JP
	ld	de,hook_check_code_1st
	ld	c,3
	call	memchk
;hook before startup OS
	ld	hl,hook_2nd
	ld	(STC_HOOK_1ST_JP+1),hl		;OS SETUPへのジャンプ
	jp	6000h
;------------------------------------------------
;mfr LOGO , load & run OS
;------------------------------------------------
hook_2nd:
;  0000-3E15 : OS
;  3E16-4xxx : OS BOOT CODE
;  5000-5EFF : loader & patch data
;  6000-EFFF : EMM preload buffer

;------------------
;compatible check
	ld	hl,0F82H
	ld	de,hook_check_code_0f82
	ld	c,3
	call	memchk
;------------------
;bypass EMM cache
IC_EMM_BYPASS_JR	equ		03F58H	;	jr	z,L3F6A
	ld	a,(B_EMM_DISABLE)
	or	a
	jr	z,emm_auto
	ld	a,18h		;JR Z, --> JR
	ld	(IC_EMM_BYPASS_JR),A
emm_auto:

;------------------
;force PSG
IC_FM_NOTFOUND_JR		equ	03E6AH	; jr	nz,L3E6D
	ld	a,(B_SOUND_PSG)
	or	a
	jr	z,sound_auto
	ld	a,018h			;JR
	ld	(IC_FM_NOTFOUND_JR),A
sound_auto:

;------------------
;hook before start OS
STC_HOOK_2ND_JP_Z		equ	0x3F88	; JP Z,02E6H
;compatible check
	ld	hl,STC_HOOK_2ND_JP_Z
	ld	de,hook_check_code_2nd
	ld	c,3
	call	memchk
;hook before start OS
	ld	hl,hook_3rd
	ld	(STC_HOOK_2ND_JP_Z+1),hl
;go OS BOOT CODE
	JP 0000H
;------------------------------------------------
;setup TXT-VRAM , preload EMM , init CTC and FM
;  0000-3E15 : OS
;  5000-5EFF : loader & patch data
;------------------------------------------------
hook_3rd:

;------------------
;replace POLYGON DRAWER
	ld	hl,stc_put_pat	;Fast Gfx engine
	ld	a,(B_NORMAL_GFX)
	or	a
	call	nz,patch

;------------------
;start OS
STC_OS_START		equ	0x02F1	; 02E6H
	JP STC_OS_START
;------------------------------------------------

;------------------------------------------------
;メモリのコンペアチェック
memchk:
	ld	b,0
	call	memcmp
	ret	z
;	pop	hl	;purge caller
;compatible error
	di
	call	txt_cls
;palet GFX off , text on
	ld	bc,1300h	;prio on
	ld	a,10h-1
halt_palet_l:
	out	(c),c
	dec	b
	cp	b
	jr	nz,halt_palet_l
;error message
	ld	hl,0
	ld	(w_cur_xy),hl
	ld	hl,msg_cmp_err
	call	puts
	jr	$

;------------------------------------------------
;memory check data

hook_check_code_1st:
	db	0C3H,000H,000H	;	JP 0000H

hook_check_code_2nd:
	db	0CAH,0E6H,002H	;	JP Z,026E6

;
hook_check_code_0f82
	db	0CDH,0EDH,008H	;	CALL 08EDH


;------------------------------------------------
;configuration data
;------------------------------------------------
D_CONFIG:
B_EMM_DISABLE:
	db	0
B_SOUND_PSG:
	db	0
B_NORMAL_GFX:
	db	1
B_KBD_MODEB:
	db	0
	db	0
;
