;--------------------------------------------------------------------
;StarCruiser Extend Patcher IPL
;
;note:
;  0000-3E15 : OS
;  3E16-3fxx : OS BOOTUP CODE
;  6000-6BFF : IPL logo
;  F000-???? : IPL logo work
;
;  6000-EFFF : EMM preload buffer
;
;  5000-5FFF : patcher code
;
;--------------------------------------------------------------------
PROGRAM_TOP	equ	0x5000

;--------------------------------------------------------------------
;IPL-ROM
;IPL_DRIVE	equ	0FF81H

;--------------------------------------------------------------------
;X1 IPL FCB BLOCK
;--------------------------------------------------------------------
	org	PROGRAM_TOP-32
;
IPL_FCB:
	db	01h		;type
	db	"StarCruiserEX"		;name
	db	"Sys"				;extenstion
	db	20h					;passeord
	dw	PROGRAM_END-IPL_FCB	;size
	dw	PROGRAM_TOP-32		;top
	dw	entry				;entry
	db	0,0,0,0,0			;date
	db	0,0,0				;start recoard
;
;--------------------------------------------------------------------
;	org	PROGRAM_TOP
;--------------------------------------------------------------------
entry:
	di
	jp	setup
;------------------------------------------------
;main loader
boot_start:
	include	"loader.asm"
;------------------------------------------------
;main patch code
stc_put_pat:
	include	"stc_put_pat.asm"
;------------------------------------------------
;pacher
	include	"patch.asm"
;	CHK_LIMIT	0x5F00

;------------------------------------------------
;以下、起動開始後は切り離しOK
;------------------------------------------------

;------------------------------------------------
;start entry
;------------------------------------------------
setup:
	ld	sp,0
;------------------------------------------------
;check boot drive
;	ld	a,(IPL_DRIVE)
;	and	1
;	cp	1
;	jp	nz,boot_error
;midify boot drive
;	xor	a
;	ld	(IPL_DRIVE),a	;modify BOOT 

;------------------------------------------------
;boot message
	call	txt_cls
	ld	hl,msg_title
	call	puts

;------------------------------------------------
;SETUP MENU

;------------------------------------------------
;
error_loop:
	call	config
;------------------------------------------------
;wait RETURN KEY
inkey_w:
;	call	inkey_ni
;	cp	0dh
;	jr	nz,inkey_w

;------------------------------------------------
;GO BOOT 

;------------------------------------------------
;load disk ID sector
	ld	a,1
	ld	(FD_DRIVE),a
	ld	hl,7000h	;IPL-FCB + BODY
	ld	de,0020h	;recoard number
	ld	a,1			;number of recoard
	call	FD_READ
	ld	hl,7000h+001AH
	ld	de,d_fd1_compare
	ld	bc,8
	call	memcmp
	jp	nz,disk_err
;------------------------------------------------
;load StarCruiser IPL
	xor	a
	ld	(FD_DRIVE),a
	ld	hl,5F00h	;IPL-FCB + BODY
	ld	de,0		;recoard number
	ld	a,1+12		;number of recoard
	call	FD_READ
;------------------------------------------------
;check DISK compatible & start
	ld	hl,5F00h
	ld	de,d_fd0_compare
	ld	bc,18h
	call	memcmp
	jp	nz,disk_err
;------------------------------------------------
;exec loader
	jp	boot_start
;------------------------------------------------
;disk check error
disk_err:
	ld	hl,20*256 +10
	ld	(w_cur_xy),hl
	ld	hl,msg_disk_err
	call	puts
;
	jr	error_loop
;------------------------------------------------

;------------------------------------------------
;FD check data

;drive0,track0,sector1,offset0
d_fd0_compare:
	db	01h
	db	"STAR CRUISER Sys"
	db	20h
	dw	0x0c00,0x6000,0x6000

;drive1,track2,sector1,offset1A
d_fd1_compare:
	db	"sys DATA"


;------------------------------------------------
	include	"msg.asm"
	include	"config.asm"
	include	"ipl_fd_read.asm"
;------------------------------------------------
	include	"memcmp.asm"
	include	"puts.asm"
	include	"txt_cls.asm"
	include	"scpu.asm"
	include	"inkey_ni.asm"
;
PROGRAM_END	equ	$
